var FleksyAPI,
extensionsData,
activeExtensionsData,
inventoryData,
freeInventoryData,
priceData,
purchaseData,
syncedExtensionsData,
i18nData,
count = 0, // figures out when the store is ready
flag = 0, // stops the UI binding from happening more than once
slotsReady = false, // tracks when the unlocked slots area is ready
slotsSwiper;

function setPlatform( name ) {
	if ( name == "Android" ) {
		FleksyAPI = new FleksyAPIAndroid();
		FleksyAPI.requestExtensionsData();
		FleksyAPI.requestStoreData();
	} else if ( name == 'iOS' ) {
		FleksyAPI = new FleksyAPIiOS();
		FleksyAPI.requestExtensionsData();
		FleksyAPI.requestStoreData();
	} else {
		//console.log("Undefined Platform!");
	}
}

// Not needed callbacks
function themesCallback( themes ) { }
function selectedThemeCallback( key, result ) { }

function onDestroyCallback() { }

function stringsCallback( strings ) {
	if ( typeof strings === 'string' ) {
		i18nData = $.parseJSON( strings );
	} else {
		i18nData = strings;
	}

	if ( count >= 2 ) {
		FLExtensions.translateStrings(i18nData);
	} else {
		_.delay(stringsCallback, 250, strings);
	}
}

// Required callbacks
function freeInventoryCallback( free_inventory ) {
	if ( typeof free_inventory == 'string' ) {
		freeInventoryData = $.parseJSON( free_inventory );
	} else {
		freeInventoryData = free_inventory;
	}

	//console.log('freeInventoryCallback');
	//console.log(freeInventoryData);

	count++;

	if ( count >= 2 ) {
		FLExtensions.init();
	}
}

function inventoryCallback( inventory ) {
	if ( typeof inventory == 'string' ) {
		inventoryData = $.parseJSON( inventory );
	} else {
		inventoryData = inventory;
	}

	//console.log('inventoryCallback');
	//console.log(inventoryData);

}

function purchasedCallback( purchases ) {
  if ( typeof purchases == 'string' ) {
		purchaseData = $.parseJSON( purchases );
  } else {
		purchaseData = purchases;
  }
	//console.log('purchasedCallback');
	//console.log(purchaseData);

	count++;

	if ( count >= 2 ) {
		FLExtensions.init();
	}
}

function pricesCallback( prices ) {
  if ( typeof prices == 'string' ) {
		priceData = $.parseJSON(prices);
  } else {
  	priceData = prices;
  }

	//console.log('pricesCallback');

}

function purchaseResultCallback(id, result) {
	//console.log("purchaseResultCallback id: " + id + " result: " + result, true);
	if ( result === 'success' || result === '200 OK' ) {
		s.purchases.push( id );
		FLExtensions.bindPurchasedSlot();
	} else {
		//FleksyAPI.log( result );
	}
}

function extensionsCallback( extensions ) {
	if ( typeof extensions == 'string' ) {
		extensionsData = $.parseJSON( extensions );
	} else {
		extensionsData = extensions;
	}

	//console.log('extensionsCallback');
}

function setActiveExtensionsCallback(active_extensions, result) {
	if ( typeof active_extensions == 'string' ) {
		activeExtensionsData = $.parseJSON( active_extensions );
	} else {
		activeExtensionsData = active_extensions;
	}

	//console.log(JSON.stringify(activeExtensionsData));
	//console.log('setActiveExtensionsCallback');

	if ( slotsReady && extensionsData ) {
		FLExtensions.populateExtensions();
		flag++;
	} else {
		_.delay(setActiveExtensionsCallback, 250, active_extensions);
	}
}

function tutorialStateCallback( isVisible ) {
	//console.log('tutorialStateCallback', + " " + isVisible);
	var tutorial = $(".tutorial");

	if ( isVisible ) {
		tutorial.css('display', 'block');
	}
}

function syncedExtensionsCallback( synced_extensions ) {
	if ( typeof synced_extensions == 'string' ) {
		syncedExtensionsData = $.parseJSON( synced_extensions );
	} else {
		syncedExtensionsData = synced_extensions;
	}

	if ( count >= 2 ) {
		FLExtensions.setSetupLabels(syncedExtensionsData.synced_extensions);
	} else {
		_.delay(syncedExtensionsCallback, 1000, syncedExtensionsData.synced_extensions);
	}
}

var test_data = false;

var s,
FLExtensions = {
	settings: {
		extensions: null,
		active_extensions: null,
		inventory: null,
		prices: null,
		purchases: null,
		freeInventory: null,
		i18nStrings: null,
		inventoryLookup: {}
	},

	/**
	 * Main init method.
	 */
	init: function() {
		s = this.settings;

		if ( test_data ) {
			s.extensions = JSON.parse(extensionsString);
			s.active_extensions = JSON.parse(activeExtensionsString).active_extensions; //TODO examine if this needs transferring
			s.inventory = JSON.parse(itemString).inventory;
			s.prices = JSON.parse(priceString);
			s.purchases = JSON.parse(purchaseString).purchases;
			s.freeInventory = JSON.parse(freeInventoryString).free_inventory;
			s.syncedExtensions = JSON.parse(syncedExtensionsString).synced_extensions;
			s.maxAllowedSlots = 8;
		} else {
			s.extensions = extensionsData.extensions;
			s.inventory = inventoryData.inventory;
			s.prices = priceData;
			s.purchases = purchaseData.purchases;
			s.freeInventory = freeInventoryData.free_inventory;
			s.syncedExtensions = syncedExtensionsData ? syncedExtensionsData.free_inventory : '';
			s.maxAllowedSlots = 8;
			s.i18nStrings = i18nData || null;
		}

		for ( var i = 0, len = s.inventory.length; i < len; i++ ) {
			s.inventoryLookup[s.inventory[i].key] = s.inventory[i];
		}

		this.createSlots();
	},

	populateExtensions: function() {
		if ( !test_data ) {
			s.active_extensions = activeExtensionsData.active_extensions;
			s.extensions = extensionsData.extensions;
			s.syncedExtensions = syncedExtensionsData ? syncedExtensionsData.synced_extensions : '';
		}

		if ( !flag ) {
			this.determineTutorialState();
			// Popuplate extension should be in this order because even if the makeExtension method builds the extension settings page
            // it's only added on populateInactiveExtensions so any modifications made by populateActiveExtensions
            // need to be after this call or it won't be shown in the UI (no comments)
			this.populateInactiveExtensions();
			this.populateActiveExtensions();
			this.bindExtensionsUI();
			this.bindExtensionSettingsTrigger();
			this.setExtensionsState(s.active_extensions);
			this.bindExtensionDraggable();
			this.setupSlotsSwiper();
			this.setSetupLabels(s.syncedExtensions);
			this.bindTapFeedback();
		}
		flag++;
	},

	setSetupLabels: function( syncedExtensions ) {
		if ( syncedExtensions ) {
			_.each(s.extensions, function( obj ) {
				if ( obj.needs_login ) {
					var setting = $(".ext-settings").filter(function() {
						return $(this).data('key') == obj.key;
					});

					var label = _.contains(syncedExtensions, obj.key) ? 'Sign Out' : 'Sign In';
					setting.find('.ext-setup').text(label);
				}
			});
		}
	},

	getInventorySlots: function() {
		var slots = [];

		_.each(s.inventory, function(obj) {
			if ( obj.key.indexOf('slot') !== -1 ) {
				slots.push(obj.key);
			}
		});

		return slots;
	},

	getPurchasableSlotKey: function() {
		var purchasedSlots = _.filter( s.purchases, function( key ) {
			return key.indexOf('slot') !== -1;
		});

		return _.difference( FLExtensions.getInventorySlots(), purchasedSlots )[0];
	},

	canBuyMoreSlots: function() {
		return false
	},

	getPurchasedSlots: function( boxes ) {
		// create a lookup object for our inventory
		var purchasedSlots = [];

		_.each(boxes, function( key ) {
			if ( typeof s.inventoryLookup[key] !== 'undefined' && s.inventoryLookup[key].unlocks_keys && ! _.isEmpty(s.inventoryLookup[key].unlocks_keys) ) {
				purchasedSlots = purchasedSlots.concat( FLExtensions.getPurchasedSlots( s.inventoryLookup[key].unlocks_keys ));
			}
		});

		_.each(boxes, function( key ) {
			if ( ( key in s.inventoryLookup ) ) {
				purchasedSlots = purchasedSlots.concat([key]); //TODO avoid infinite loop
			}
		});

		return _.uniq(_.filter(purchasedSlots, function(key) { return ~key.indexOf('slot') }));
	},

	getUnlockedSlotsNo: function() {
		return 10;
	},

	bindPurchasedSlot: function() {
		var $buyBtnSlide = $('.buy-slot-slide');

		var newSlotsNo = FLExtensions.getUnlockedSlotsNo() - $(".swiper-wrapper").find('.slot').not('.disabled, .slot-highlights').length;

		if ( newSlotsNo > 0 ) {
			for ( var i = 0; i < newSlotsNo; i++ ) {
				$buyBtnSlide.before('<div class="swiper-slide"><div class="slot"></div></div>');
			}
		}

		FLExtensions.bindSlotsUI();

		if ( ! FLExtensions.canBuyMoreSlots() ) {
			$buyBtnSlide.hide();
		}

		$('.swiper-container')[0].swiper.update();
	},

	createSlots: function() {
		var $slotArea = $(".swiper-wrapper"),
				$currentSlots = $slotArea.find(".slot").not('.disabled, .slot-reserved'),
				$buyBtnSlide = $('.buy-slot-slide'),
				slots = '';

		var slotDifference = FLExtensions.getUnlockedSlotsNo() - $currentSlots.length;


		if ( slotDifference > 0 ) {
			var reserved = '';
			// add an extra special slot for the highlights
			for ( var i = 0; i < slotDifference + 1; i++ ) {
				reserved = i === 0 && !$currentSlots.length ? 'slot-reserved slot-highlights' : '';

				slots += '<div class="swiper-slide"><div class="slot ' + reserved +'"></div></div>';
			}
			$buyBtnSlide.before(slots);
		} else {
			//TODO figure out how to remove slots efficiently.
			//console.log(slotDifference);
			//slotArea.find(".slot:last-child").remove();
			//FLExtensions.setActiveExtensions();
			//FLExtensions.init();
			//FLExtensions.populateInactiveExtensions();
		}

		//console.log('CreateSlots');

		if ( FLExtensions.canBuyMoreSlots() ) {
			$buyBtnSlide.show();
		} else {
			$buyBtnSlide.hide();
		}

		FLExtensions.bindSlotsUI();

		if ( $('.swiper-container')[0].swiper ) {
			$('.swiper-container')[0].swiper.update();
		}

		slotsReady = true;
	},

	/**
	 * Materializes a single extension square block.
	 * Extracts the required params from the extensions' object (JSON) and
	 * applies the relative CSS.
	 *
	 * @param {string} id The extension's unique ID
	 * @return {object} extension The extension jQuery object, ready to be appended in the DOM
	 */
	makeExtension: function( id, isActive ) {
		var extObj = _.where(s.extensions, {"key": id})[0];

		if ( !extObj ) {
			return false;
		}

		var extension = $(".extension.template").clone().removeClass('template');
		var extSettings = $(".ext-settings.template").clone().removeClass('template');
		extension.data('id', id);
		extension.find('.extension-title').text(extObj.title);
		extension.css('background-color', extObj.design.color);
		extension.find('.extension-icon i').addClass(extObj.design.icon_class);
		extension.find('.extension-description').text(extObj.description);
		extension.attr('data-featherlight', '#settings_' + id);

		if ( extObj.allows_multiples ) {
			extension.data('allows_multiples', 'true');
		} else {
			extension.data('allows_multiples', 'false');
		}

		extSettings.data('key', id);
		extSettings.attr('id', 'settings_' + id);
		extSettings.css('background-color', extObj.design.color);
		extSettings.find('.extension-icon i').addClass(extObj.design.icon_class);
		extSettings.find('.extension-description').text(extObj.description);

		if ( extObj.needs_login === true ) {
			extension.find('.ext-setup').text('Sign In');
		} else if ( ! extObj.settings && ! extObj.needs_login ) {
			extSettings.find('.ext-setup').remove();
		}

		if (extObj.isPinned && isActive) {
		    // If the extension is pinned and is active, remove the 'remove' action button from the extension settings sheet
		    // and we need to do this way because the extSettings object is not added when it's an active extension
		    // it was added when the extension was added as inactive
		    $("#settings_" + id).find(".ext-equip").remove();
        }

		return {
			extension: extension,
			extSettings: extSettings
		};
	},

	/**
	 * Populates the #extensions (inactive extensions area).
	 */
	populateInactiveExtensions: function() {
		$("#extensions").html();
		var extensionKeys = _.map(s.extensions, function(obj) {
			return obj.key;
		});

		_.each(extensionKeys, function( key ) {
			var extensionData = _.where(s.extensions, {'key': key})[0];

				if ( typeof extensionData.public === 'undefined' || extensionData.public !== false ) {
					var extensionObj = FLExtensions.makeExtension(key, false);

					if ( extensionObj ) {
					    // Here we add the extension and the extension settings page (so only added when adding the inactive extension)
						extensionObj.extension.appendTo("#extensions");
						extensionObj.extSettings.appendTo('.extension-settings');
					}
				}
		});
	},

	/**
	 * Populates active extension slots.
	 */
	populateActiveExtensions: function() {
		_.each(s.active_extensions, function( key, index ) {
			if ( key && key !== "null" && _.findWhere(s.extensions, {"key": key}) ) {
				FLExtensions.makeExtension(key, true).extension.appendTo($("#extensions-active").find('.swiper-slide').eq(index).find('.slot'));
			}
		});

		//FleksyAPI.setActiveExtensions( active_extensions );
	},

	/**
	 * Sets / unsets extensions.
	 */
	setActiveExtensions: function() {
		s.active_extensions = activeExtensionsData.active_extensions;

		var active_extensions = [];

		$("#extensions-active").find('.slot').not('.disabled').each(function() {
			active_extensions.push($(this).find('.extension').data('id'));
		});

		FleksyAPI.setActiveExtensions(active_extensions);
		FLExtensions.setExtensionsState(active_extensions);
	},

	setExtensionsState: function(active_extensions) {
		_.each(s.extensions, function(obj) {
			var extension = $("#extensions .extension").filter(function(idx, ext) {
				return obj.key == $(ext).data('id');
			});

			if ( FLExtensions.canExtensionBeActivated(obj.key, active_extensions) ) {
				extension.removeClass('disabled');
			} else {
				extension.addClass('disabled');
			}
		});

		FLExtensions.bindExtensionDraggable();
	},

	bindEquipBtn: function() {
		$(".ext-equip").on('click', function() {
			var that = $(this);
			var extKey = that.parent().data('key');
			var idx = that.parent().data('idx');
			var textOneCopy = s.i18nStrings !== null ? s.i18nStrings.extensions.activation_limit_message : 'Only one copy of this extension may be activated';
			var textFull = s.i18nStrings !== null ? s.i18nStrings.extensions.extensions_full_message : 'Slots full, remove an extension to make room';

			if ( that.hasClass('disabled') ) {
				FleksyAPI.showToast(textOneCopy, true);
			} else if ( that.hasClass('inactive') ) {
				FleksyAPI.showToast(textFull, true);
			} else if ( that.hasClass('unequip') ) {
				FLExtensions.unEquipExtension(extKey, idx);
			} else {
				FLExtensions.equipExtension(extKey);
			}
		});
	},

	equipExtension: function(key) {
		var extension = $("#extensions").find('.extension').filter(function() {
											return $(this).data('id') === key;
										});

		var tutorial = $(".tutorial");

		$.featherlight.current().close();

		if ( extension.data('id') === 'extension_key_highlights' ) {
			$('.swiper-container')[0].swiper.slideTo(0);
			var slot0 = $('.slot-highlights');
			extension.clone(true).appendTo(slot0);
		} else {
			var $firstEmptySlot = $('.slot').not('.slot-reserved, .disabled').filter(function(idx, slot) {
				return !$('.extension', this).length;
			}).first();

			if ( $firstEmptySlot.parent().index() > 2) {
				$('.swiper-container')[0].swiper.slideTo($firstEmptySlot.parent().index());
			}
			extension.clone(true).appendTo($firstEmptySlot);
		}

		if ( tutorial.is(":visible") ) {
			tutorial.slideUp();
		}
		FLExtensions.setActiveExtensions();

	},

	unEquipExtension: function(key, idx) {
		$.featherlight.current().close();

		$('.swiper-wrapper').find('.swiper-slide').eq(idx).find('.extension').fadeOut(function() {
			$(this).remove();
			FLExtensions.setActiveExtensions();
		});

	},

	canExtensionBeActivated: function(key, active_extensions) {
		active_extensions = active_extensions || s.active_extensions;

		var extension = $("#extensions .extension").filter(function (idx, ext) {
				return key == $(ext).data('id');
			}),
			extObj = _.where(s.extensions, { 'key': key })[0],
			noOfExtensionActivations = _.filter(active_extensions, function (value) {
				return value == key;
			}).length;

		if ( ( typeof extObj.allows_multiples === 'undefined' || !extObj.allows_multiples ) && active_extensions.indexOf(extObj.key) !== -1 ) {
			return false;
		} else {
			if ( noOfExtensionActivations < s.maxAllowedSlots ) {
				return true;
			} else {
				return false;
			}
		}
	},

	bindSetupBtn: function() {
		var btn = $(".ext-setup");
		btn.on('click', function() {
			var that = $(this);
			var extensionKey = that.parent().data('key');

			FleksyAPI.showExtensionSettings(extensionKey);
		});
	},

	bindSlotsUI: function() {
		interact('.slot').dropzone({
			accept: '.extension',
			overlap: 0.4,
			ondropactivate: function(event) {
				var $draggableElement = $(event.relatedTarget);

				if ( $draggableElement.data('id') === 'extension_key_highlights' ) {
					$('.slot-highlights').addClass('highlight');
				} else {
					$('.slot').not('.slot-reserved').addClass('highlight');
				}
			},
			ondrop: function(event) {
				var $slot = $(event.target),
						$occupant = $slot.find('.extension'),
						$extension = $(event.relatedTarget),
						$slotHighlights = $('.slot-highlights');

				if ( $slot.hasClass('disabled') ) {
					FleksyAPI.purchaseBox( FLExtensions.getPurchasableSlotKey() );
					return false;
				}

				if ( $slot.is($slotHighlights) ) {
					if ( $extension.data('id') === 'extension_key_highlights' ) {
						$extension.detach().css({top: 0,left: 0}).appendTo($slotHighlights);
						$('.swiper-container')[0].swiper.slideTo($slotHighlights.parent().index());
					} else {
						var $nextAvailableSlot = $('#extensions-active').find('.slot').not('.slot-highlights, .disabled').filter(function() {
							return !$(this).children().length;
						}).first();

						if ( $nextAvailableSlot.length ) {
							$extension.detach().css({top: 0,left: 0}).appendTo($nextAvailableSlot);
							$('.swiper-container')[0].swiper.slideTo($nextAvailableSlot.parent().index());
						} else {
							var textFull = s.i18nStrings !== null ? s.i18nStrings.extensions.extensions_full_message : 'Slots full, remove an extension to make room';
							FleksyAPI.showToast(textFull, true);

							$extension.remove();
						}
					}
				} else {
					if ( $extension.data('id') === 'extension_key_highlights' ) {
						$extension.detach().css({top: 0,left: 0}).appendTo($slotHighlights);
						$('.swiper-container')[0].swiper.slideTo($slotHighlights.parent().index());
					} else {
						$extension.detach().css({top: 0,left: 0}).appendTo($slot);

						if ( $occupant.length && !$occupant.is($extension) ) {
							$occupant.remove();
						}
					}
				}

				$extension.removeClass('dragging');
				$extension.css('position', 'relative');
				event.relatedTarget.style.webkitTransform =
				event.relatedTarget.style.transform = 'scale(1)';
				$('.slot').removeClass('highlight');
				FLExtensions.setActiveExtensions();
				FLExtensions.bindExtensionSettingsTrigger();

				// Hide the tutorial
				var tutorial = $(".tutorial");
				if ( tutorial.is(":visible") ) {
					tutorial.slideUp();
				}
			},
			ondragenter: function(event) {
				var draggableElement = event.relatedTarget,
        dropzone  = event.target,
        dropRect         = interact.getElementRect(dropzone),
        dropCenter       = {
          x: dropRect.left + dropRect.width  / 2,
          y: dropRect.top  + dropRect.height / 2
        };

				//if ( $(draggableElement).data('id') === 'extension_key_highlights' ) {
				//	$('.slot-highlights').addClass('drop-hover');
				//} else {
				//	$(dropzone).addClass('drop-hover');
				//}

				if ( $(draggableElement).data('id') === 'extension_key_highlights' ) {
					$('.slot-highlights').addClass('drop-hover');
				} else {
					if ( !$(dropzone).hasClass('slot-highlights') ) {
						$(dropzone).addClass('drop-hover');
					}
				}

				event.draggable.draggable({
					snap: {
						targets: [dropCenter]
					}
				});
			},
			ondragleave: function(event) {
				$(event.target).removeClass('drop-hover');
			},
			ondropdeactivate: function(event) {
				$(event.target).removeClass('highlight, drop-hover');
			}
		});
	},

	setupSlotsSwiper: function() {
		slotsSwiper = new Swiper('.swiper-container', {
			slidesPerView: 'auto',
			slidesPerGroup: 3,
			onTouchStart: function(swiper, event) {
				FleksyAPI.holdHorizontalSlide();
			},
			onTouchMove: function(swiper, event) {
				FleksyAPI.holdHorizontalSlide();
				if ( interact.isSet('.extension:not(.disabled)') ) {
					interact('.extension:not(.disabled)').unset();
				}
			},
			onTouchEnd: function(swiper, event) {
				FleksyAPI.resumeHorizontalSlide();
				FLExtensions.bindExtensionDraggable();
			}
		});
	},

	/**
	* Binds drag & drop functionality for the extensions themselves.
	*/
	bindExtensionDraggable: function() {
		var startPos = null;

		interact('.extension:not(.disabled)')
		.on('hold', function(event) {
			$('.swiper-container')[0].swiper.detachEvents();
			$('.ripple-effect').remove();

			var $body = $('body'),
					interaction = event.interaction,
					original = event.currentTarget,
					$original = $(original),
					clone = original.cloneNode(true),
					y = $original.offset().top,
					x = $original.offset().left;

			if ( $original.parent().hasClass('slot') ) {
				$original.addClass('dragging');
				original.style.webkitTransform =
				original.style.transform = 'scale(1.1) translate3d(0, 0, 10px)';

				if ( !interaction.interacting() ) {
					interaction.start({ name: 'drag' }, event.interactable, event.currentTarget);
				}
			} else {
				if ( interaction.pointerIsDown && !interaction.interacting() ) {
					$original.addClass('disabled'); //TODO fix this for extensions that allowmultiples?
					// insert the clone to the page
					var $clone = $(clone);
					$clone.data('id', $original.data('id'));
					$clone.css({
						'position': 'absolute',
						'top': y - $("#extensions-active").outerHeight(),
						'left': x
					}).addClass('dragging');

					clone.setAttribute('data-x', x);
					clone.setAttribute('data-y', y - $("#extensions-active").outerHeight());

					document.getElementById('extensions').appendChild(clone);

					setTimeout(function() {
						clone.style.webkitTransform =
						clone.style.transform = 'scale(1.1)';
					}, 0);

					// start a drag interaction targeting the clone
					interaction.start({ name: 'drag' }, event.interactable, clone);
				}
			}
			FleksyAPI.holdHorizontalSlide();
		})
		.draggable({
			manualStart: true,
			snap: {
				targets: [startPos],
				range: Infinity,
				relativePoints: [{ x: 0.5, y: 0.5 }],
				endOnly: true
			},
			inertia: true,
			onstart: function(event) {
				var rect = interact.getElementRect(event.target);

				// record center point when starting the drag
				startPos = {
					x: rect.left + rect.width  / 2,
					y: rect.top  + rect.height / 2
				};

				// snap to the start position
				event.interactable.draggable({
					snap: {
						targets: [startPos]
					}
				});


				if ( $(event.target).parent('.slot').length ) {
					event.interactable.draggable({
						inertia: {
							resistance: 1200
						}
					});
				}
			},
			onend: function(event) {
				var target = event.target;
				target.setAttribute('data-x', 0);
				target.setAttribute('data-y', 0);
				$('.swiper-container')[0].swiper.attachEvents();

				if ( ! $(target).parent().hasClass('slot') ) {
					target.style.webkitTransform =
					target.style.transform = 'scale(1)';

					$(target).animate({
						'opacity': 0
					}, 200, function() {
						$(this).remove();
					});

					FLExtensions.setExtensionsState(s.active_extensions);
				}

				$('.slot').removeClass('highlight');

				FleksyAPI.resumeHorizontalSlide();
			},
			onmove: function(event) {
				var target = event.target,
						x = ( parseFloat(target.getAttribute('data-x')) || 0 ) + event.dx,
						y = ( parseFloat(target.getAttribute('data-y')) || 0 ) + event.dy;

				$(target).css({
					'top': y+'px',
					'left': x+'px'
				});

				target.setAttribute('data-x', x);
				target.setAttribute('data-y', y);

				if ( event.interaction.interacting() ) {
					event.preventDefault();
				}
			}
		})
		.on('contextmenu', function(event) {
			event.preventDefault();
		});
	},

	/**
	 * Binds inactive extensions dropzone events and
	 * all other relevant functionality.
	 */
	bindExtensionsUI: function() {
		// Tutorial Button
		$(".btn-tutorial").on("click", function(e) {
			$(this).parent().slideUp();
			FleksyAPI.tapNotify('dismiss-tutorial');

			e.preventDefault();
		});

		var $extensions = $("#extensions");

		interact('#extensions').dropzone({
			accept: '.slot .extension',
			ondropactivate: function(event) {
				$extensions.addClass('highlight');
			},
			ondropdeactivate: function(event) {
				$extensions.removeClass('highlight');
			},
			ondrop: function(event) {
				var dropzone = $(event.target),
						draggableElement = $(event.relatedTarget);

				$(draggableElement).addClass('grow').animate({
					'opacity': 0
				}, 220, function() {
					$(this).remove();
					FLExtensions.setActiveExtensions();
				});

				//reset inertia resistance back to normal
				event.draggable.options.drag.inertia.resistance = 10;
			},
			ondragenter: function(event) {
				var dropPoint = null;

				event.draggable.draggable({
					snap: {
						targets: [dropPoint]
					}
				});
			}
		});

		FLExtensions.bindEquipBtn();
		FLExtensions.bindSetupBtn();

		$(".buy-slot").on("click", function(e) {
			FleksyAPI.purchaseBox( FLExtensions.getPurchasableSlotKey() 	);

			e.preventDefault();
		});

		FLExtensions.bindTweetButton();
	},

	bindExtensionSettingsTrigger: function() {
		$(".extension:not(.disabled)").featherlight({
			openSpeed: 0,
			closeSpeed: 0,
			beforeOpen: function(event) {
				//get the extension tapped and reference it in the settings
				var $currentTarget = $(event.currentTarget);
				FLExtensions.setEquipLabels($currentTarget);
			},
			afterOpen: function(event) {
				var $currentTarget = $(event.currentTarget);

				if ( $currentTarget.parent('.slot').length ) {
					$('.featherlight-inner').data('idx', $currentTarget.parents('.swiper-slide').index());
				}
			}
		});
	},

	setEquipLabels: function($target) {
		var isFull = $(".slot").not('.disabled').length == $("#extensions-active").find(".extension").length,
				isHighlightsSlotPopulated = $('.swiper-slide').eq(0).find('.slot').children().length,
				slotted = $target.parent('.slot').not('.disabled').length,
				$label = $('.ext-settings').find('.ext-equip'),
				textRemove = s.i18nStrings !== null ? s.i18nStrings.extensions.remove_extension_button : 'Remove',
				textAdd = s.i18nStrings !== null ? s.i18nStrings.extensions.add_extension_button : 'Add';

                // hide the keyboard to show the extension details
				FleksyAPI.dismissKeyboard();


		if ( ( !slotted && isFull ) ) {
			$label.text(textAdd).removeClass('unequip disabled').addClass('inactive');
		} else if ( $target.hasClass('disabled') ) {
			$label.text(textAdd).removeClass('unequip').addClass('inactive disabled');
		} else if ( slotted ) {
			$label.text(textRemove).addClass('unequip').removeClass('inactive disabled');
		} else {
			$label.text(textAdd).removeClass('inactive unequip disabled');
		}
	},

	determineTutorialState: function() {
		var tutorial = $(".tutorial");

		if ( ( typeof s.active_extensions == 'undefined' ) || (! s.active_extensions.length) ) {
			tutorial.css('display', 'block');
		}
	},

	bindTapFeedback: function() {
		$('body').on('touchstart', '.extension', function (event) {
			var $div = $('<div/>'),
					thisOffset = $(this).offset(),
					xPos = event.originalEvent.touches[0].pageX - thisOffset.left,
					yPos = event.originalEvent.touches[0].pageY - thisOffset.top;

			$div.addClass('ripple-effect');
			var $ripple = $(".ripple-effect");

			$ripple.css("height", $(this).width());
			$ripple.css("width", $(this).width());
			$div
				.css({
					top: yPos - ($ripple.height()/2),
					left: xPos - ($ripple.width()/2),
					background: $(this).data("ripple-color")
				})
				.appendTo($(this));

			window.setTimeout(function(){
				$(".ripple-effect").remove();
			}, 400);
		});
	},

	bindTweetButton: function() {
		var tweetBtn = $(".twitter-share-button"),
				iOS = /(iPad|iPhone|iPod)/g.test( navigator.userAgent),
				message;

		tweetBtn.css('display', 'block');

		if ( iOS ) {
			message = s.i18nStrings !== null ? s.i18nStrings.extensions.tweet_text : ".@Fleksy lets you customize your keyboard with awesome features! I can’t wait for even more #Fleksyextensions 😄 http://fleksy.com/getiOS ";
		} else {
			message = s.i18nStrings !== null ? s.i18nStrings.extensions.tweet_text : ".@Fleksy lets you customize your keyboard with awesome features! I can’t wait for even more #Fleksyextensions 😄 http://fleksy.com/upgradenow ";
		}

		tweetBtn.on( 'click', function( e ) {
			e.preventDefault();
			FleksyAPI.tweet( message );
		});
	},

	translateStrings: function( translations ) {
		$('[data-i18n]').each(function() {
			var that = $(this),
					pointer = that.data('i18n').split('.');

			that.html( translations[pointer[0]][pointer[1]] );
		});
	}
};

(function() {
	var iOS = /(iPad|iPhone|iPod)/g.test( navigator.userAgent );
	if ( iOS ) {
		$("body").addClass("ios");
	}

	$(document).on('scroll', function() {
	 	var extensionsActive = $("#extensions-active");

		if ( extensionsActive.offset().top > 8 ) {
			extensionsActive.addClass('ontop');
		} else {
			extensionsActive.removeClass('ontop');
		}
	});

	$(document).on('touchcancel', function(e) {
		if ( !interact.isSet('.extension:not(.disabled)') ) {
			FLExtensions.bindExtensionDraggable();
		}
	});

	//test purposes only TBR
	$('.refresh').on('click', function(e) {
		location.reload();

		e.preventDefault();
	});

})();

if ( test_data ) {
	FLExtensions.init();
	FLExtensions.populateExtensions();
}

//Only for testing purposes, brings console logs in the DOM, TBR

//if (typeof console  != "undefined")
//	if (typeof console.log != 'undefined')
//		console.olog = console.log;
//	else
//      console.olog = function() {};
//
//console.log = function(message) {
//	console.olog(message);
//	$('.data').append('<p>' + message + '</p>');
//};
//console.error = console.debug = console.info =  console.log
