

function FleksyAPIAndroid () {
  
  //Asks the platform for the latest available data, to be returned in the Callbacks.
	this.requestStoreData = function() {
    AndroidFleksy.requestStoreData();
  };
  
  //Asks the platform for the extensions data
  this.requestExtensionsData = function() {
    AndroidFleksy.requestExtensionsData();
  };
  
  //Ask the platform for the keyboard preferecnes. Size, spacebar state, etc
  this.requestSizesData = function() {
    AndroidFleksy.requestSizesData();
  };
  
  //Sets active extensions. extensions is an ordered array of extension keys.
  this.setActiveExtensions = function(extensions) {
    AndroidFleksy.setActiveExtensions(extensions);
  };
  
  //Starts purchase for id.
  this.purchaseBox = function(id) {
    AndroidFleksy.purchaseBox(id);
  };
  
  //Select theme.
  this.selectTheme = function(id) {
    AndroidFleksy.selectTheme(id);
  };
  
  // Select theme for free.
  this.selectFreeTheme = function(themeKey){
    AndroidFleksy.selectFreeTheme(themeKey);
  };
  
  // Select keyboard size.
  this.selectKeyboardSize = function(size){
    AndroidFleksy.selectKeyboardSize(size);
  };
  
  // Enable/Disable spacebar
  this.selectSpacebarState = function(isEnabled){
    AndroidFleksy.selectSpacebarState(isEnabled);
  };
  
  //Navigates to extension settings if it has settings
  this.showExtensionSettings = function(extensionKey){
	  AndroidFleksy.showExtensionSettings(extensionKey);
  };

	//Dismisses the keyboard
	this.dismissKeyboard = function() {
		AndroidFleksy.dismissKeyboard();
	};

	// Tweet a message
	this.tweet = function(message) {
		AndroidFleksy.tweet(message);
	};

	// Let the platform know the user tapped something
	this.tapNotify = function( id ) {
		AndroidFleksy.tapNotify(id);
	};

	// Let platform know that it needs to stop
	// horizontal sliding of whatever view this is in
	this.holdHorizontalSlide = function() {
		AndroidFleksy.holdHorizontalSlide();
	};

	// Let platform know that it can resume
	// horizontal sliding of whatever view this is in
	this.resumeHorizontalSlide = function() {
		AndroidFleksy.resumeHorizontalSlide();
	};

	// Let platform know that it needs to stop
	// vertical sliding of whatever view this is in
	this.holdVerticalSlide = function() {
		AndroidFleksy.holdVerticalSlide();
	};

	// Let platform know that it can resume
	// vertical sliding of whatever view this is in
	this.resumeVerticalSlide = function() {
		AndroidFleksy.resumeVerticalSlide();
	};

	this.scrollTo = function(pos) {
		AndroidFleksy.scrollTo(pos);
	};

	// Open a URL in the default browser
	// @param {string} url
	this.openURL = function(url) {
		AndroidFleksy.openURL(url);
	};

	this.sendEvent = function(obj){
  	AndroidFleksy.sendEvent(obj);
 	};

	this.incrementPromotedContentSlots = function(val) {
		AndroidFleksy.incrementPromotedContentSlots(val);
	};

	/**
	* Increments promoted content views for specific campaigns
	*
	* @param {String} jsonString JSON String containing an array of campaigns.
	* format: { "campaigns": ["Campaign 1 Name", "Campaign 2 Name"] }
	*/
	this.incrementPromotedContentViewsForCampaign = function(jsonString) {
		AndroidFleksy.incrementPromotedContentViewsForCampaign(jsonString);
	};

  this.log = function(message, isToast){
	  AndroidFleksy.log(message, isToast);
  };

	this.showToast = function(message){
  	AndroidFleksy.showToast(message);
 	};

	// Open the Theme Builder, optionally loading a theme in it
	// @param {String} themeKey
	this.loadThemeBuilder = function(themeKey) {
		AndroidFleksy.loadThemeBuilder(themeKey || '');
	};

	// Initiates the platform photo gallery dialog
	this.pickImage = function() {
		AndroidFleksy.pickImage();
	};

	// Save a user generated theme
	// @param {Object} theme - the theme object
	// @param {String} themeKey - the theme's key
	this.saveUserTheme = function(theme, themeKey) {
		AndroidFleksy.saveUserTheme(theme, themeKey);
	};

	// Delete a user generated theme
	// @param {String} themeKey - the theme's key
	this.deleteUserTheme = function(themeKey) {
		AndroidFleksy.deleteUserTheme(themeKey);
	};

	// Share a theme
	// @param {String} themeKey - the theme's key
	this.shareTheme = function(themeKey) {
		AndroidFleksy.shareTheme(themeKey);
	};

	// Edit a custom user theme image
	// @param {String} imageName
	this.editThemeImage = function(imageName) {
		AndroidFleksy.editThemeImage(imageName);
	};

	// Search highlights
	// @param {String} keyword
	this.searchHighlights = function(keyword) {
		AndroidFleksy.searchHighlights(keyword);
	};

	this.coinsEarn = function() {
		AndroidFleksy.coinsEarn();
	};

	this.coinsHelp = function() {
		AndroidFleksy.coinsHelp();
	};

    this.purchaseFleksyCoinsBox = function(id){
        AndroidFleksy.purchaseFleksyCoinsBox(id);
    };

    this.notificationClick = function(target) {
        AndroidFleksy.notificationClick(target);
    }

    this.notificationHide = function(target) {
        AndroidFleksy.notificationHide(target);
    }
}
