function FleksyAPIiOS () {

	//Asks the platform for the latest available data, to be returned in the Callbacks.
	this.requestStoreData = function() {
		window.webkit.messageHandlers.inventory.postMessage("get");
	};

	//Asks the platform for the extensions data
	this.requestExtensionsData = function() {
		window.webkit.messageHandlers.xtras.postMessage("get");
	};

	//Ask the platform for the keyboard preferecnes. Size, spacebar state, etc
	this.requestSizesData = function() {
		window.webkit.messageHandlers.keyboard.postMessage("get");
	};

	//Sets active extensions. extensions is an ordered array of extension keys.
	this.setActiveExtensions = function(extensions) {
		window.webkit.messageHandlers.xtras.postMessage({ action: "put", "active_extensions": extensions });
	};

	//Starts purchase for id.
	this.purchaseBox = function(id) {
		location.href = 'fleksy://store/boxes/'+id+'/purchase';
	};
  
  // Purchase fleksycoins from id
  this.purchaseFleksyCoinsBox = function(id){
    window.webkit.messageHandlers.coins.postMessage({action : "coinPurchase", key: id});
  }

	//Select theme.
	this.selectTheme = function(id) {
		window.webkit.messageHandlers.themes.postMessage({ action: "select", key: id });
};

	// Select theme for free.
	this.selectFreeTheme = function(themeKey){

	};

	// Select keyboard size.
	this.selectKeyboardSize = function(size){
		window.webkit.messageHandlers.keyboard.postMessage({ action: "select", size: size });
	};

	// Enable/Disable spacebar
	this.selectSpacebarState = function(isEnabled){
		window.webkit.messageHandlers.keyboard.postMessage({ action: "select", spacebarIsEnabled: isEnabled });
	};

	//Navigates to extension settings if it has settings
	this.showExtensionSettings = function(extensionKey){
		window.webkit.messageHandlers.xtras.postMessage({ action: "settings", key: extensionKey });
	};

	//Dismisses the keyboard
	this.dismissKeyboard = function() {
		window.webkit.messageHandlers.keyboard.postMessage("dismiss");
	};

	// Tweet a message
	this.tweet = function(message) {
    window.webkit.messageHandlers.keyboard.postMessage({ action: "tweet", key:message});
	};

	// Let the platform know the user tapped something
	this.tapNotify = function( id ) {
    window.webkit.messageHandlers.xtras.postMessage({ action : id})
	};

	// Let platform know that it needs to stop
  // horizontal sliding of whatever view this is in
  this.holdHorizontalSlide = function() {};

  // Let platform know that it can resume
  // horizontal sliding of whatever view this is in
  this.resumeHorizontalSlide = function() {};

		// Let platform know that it needs to stop
	// vertical sliding of whatever view this is in
	this.holdVerticalSlide = function() {};

	// Let platform know that it can resume
	// vertical sliding of whatever view this is in
	this.resumeVerticalSlide = function() {};

	this.scrollTo = function(pos) {};

	// Open a URL in the default browser
	// @param {string} url
	this.openURL = function(url) {
    window.webkit.messageHandlers.keyboard.postMessage({ action : "openURL", key: url});
	};

	this.sendEvent = function(obj){
    window.webkit.messageHandlers.keyboard.postMessage({ action : "sendEvent", key: obj});
 	};

	this.incrementPromotedContentSlots = function(val) {
    window.webkit.messageHandlers.keyboard.postMessage({action: "incrementPromotedContentSlots", key: val})
	};

	/**
	* Increments promoted content views for specific campaigns
	*
	* @param {String} jsonString JSON String containing an array of campaigns.
	* format: { "campaigns": ["Campaign 1 Name", "Campaign 2 Name"] }
	*/
	this.incrementPromotedContentViewsForCampaign = function(jsonString) {
		// note: send JSON.parse(jsonString) to the platform if you want an actual object instead of a string
	};

	this.log = function(message, isToast) {};

  this.showToast = function(message) {
    window.webkit.messageHandlers.keyboard.postMessage({ action : "showToast", key: message});
  };

	// Open the Theme Builder, optionally loading a theme in it
	// @param {String} themeKey
	this.loadThemeBuilder = function(themeKey) {
    window.webkit.messageHandlers.keyboard.postMessage({action : "showThemeBuilder", key : themeKey});
	};

	// Delete a user generated theme
	// @param {String} themeKey - the theme's key
	this.deleteUserTheme = function(themeKey) {
    window.webkit.messageHandlers.keyboard.postMessage({action : "deleteUserTheme", key : themeKey});
	};

	// Share a theme
	// @param {String} themeKey - the theme's key
	this.shareTheme = function(themeKey) {
    window.webkit.messageHandlers.keyboard.postMessage({action : "shareTheme", key : themeKey});
	};

	// Search highlights
	// @param {String} keyword
	this.searchHighlights = function(keyword) {
		window.webkit.messageHandlers.keyboard.postMessage({action : "searchHighlights", key : keyword});
	};
  
  // Coins Model
  //
  // Coins Earn
  // no param
  this.coinsEarn = function(){
    window.webkit.messageHandlers.coins.postMessage({action : "coinsEarn"});
  }
  
  // Coins Help
  // no param
  this.coinsHelp = function(){
    window.webkit.messageHandlers.coins.postMessage({action : "coinsHelp"});
  }

  // Notifications
  this.notificationClick = function(target) {
    window.webkit.messageHandlers.notification.postMessage({action : "notificationClick", key: target});
  }

  this.notificationHide = function(target) {
    window.webkit.messageHandlers.notification.postMessage({action : "notificationHide", key: target});
  }
}
