var FleksyAPI,
		themeData,
		inventoryData,
		purchaseData,
		freeInventoryData,
		active_themeData,
		priceData,
		i18nData,
		isUserAtThemeTab = true,
		isAppDestroyed = false,
		count = 0;

function loadBanners(json) {
    FleksyStore.loadBanners(json);
}

function setPlatform( name ) {
	if ( name == "Android" ) {
		FleksyAPI = new FleksyAPIAndroid();
		FleksyAPI.requestStoreData();
		FleksyAPI.requestSizesData();
	} else if ( name == 'iOS' ) {
		FleksyAPI = new FleksyAPIiOS();
		FleksyAPI.requestStoreData();
		FleksyAPI.requestSizesData();
	} else {
		//console.log("Undefined Platform!");
	}
}

function onAppInvisibleCallback() {
	isAppDestroyed = true;
}

function onAppVisibleCallback() {
	isAppDestroyed = false;
}

function tabSwitchCallback(name) {
	if ( name !== 'theme' ) {
		isUserAtThemeTab = false;
	} else {
		isUserAtThemeTab = true;
		var $featuredArea = $('.swiper-featured');

		setTimeout(function() {
			if ( typeof FleksyStore !== 'undefined' && $featuredArea.find('.swiper-slide').length && FleksyStore.isElementInViewport($featuredArea) && !isAppDestroyed ) {
				var $activeBanner = $featuredArea.find('.swiper-slide-active'),
						event = $activeBanner.data('event'),
						campaigns = $activeBanner.data('campaigns');

				FleksyAPI.sendEvent(JSON.stringify(event));
				FleksyAPI.incrementPromotedContentSlots(1);
				FleksyAPI.incrementPromotedContentViewsForCampaign('{"campaigns": ' + JSON.stringify(campaigns) + '}');

			}
		}, 1000);
	}
}

function stringsCallback( strings ) {
	if ( typeof strings === 'string' ) {
		i18nData = $.parseJSON( strings );
	} else {
		i18nData = strings;
	}

	//console.log(i18nData);

	if ( count >= 4 ) {
		FleksyStore.translateStrings(i18nData);
	} else {
		_.delay(stringsCallback, 250, strings);
	}
}

// Not needed callbacks
function selectedKeyboardSizeCallback(size, result){
}

function enabledSpacebarCallback(isEnabled, result){
}

function sizesCallback(sizes) {
}

function themesCallback( themes ) {
	if ( typeof themes == 'string' ) {
		themeData = $.parseJSON( themes );
	} else {
		themeData = themes;
	}

	count++;

	//console.log("themesCallback " + count);
	//console.log(themeData);

	if ( count >= 4 ) {
		FleksyStore.init();
	}
}

function userThemesCallback( themes, imagePath ) {
	var userThemes = '';
	if ( typeof themes == 'string' ) {
		userThemes = $.parseJSON( themes );
	} else {
		userThemes = themes;
	}
	FleksyStore.createThemeBuilderInterface(userThemes, imagePath);
}

function freeInventoryCallback( free_inventory ) {
	if ( typeof free_inventory == 'string' ) {
		freeInventoryData = $.parseJSON( free_inventory );
	} else {
		freeInventoryData = free_inventory;
	}

	count++;

	//console.log("freeInventoryCallback " + count);
	//console.log(freeInventoryData);

	if ( count >= 4 ) {
		FleksyStore.init();
	}
}

function inventoryCallback( inventory ) {
	if ( typeof inventory == 'string' ) {
		inventoryData = $.parseJSON( inventory );
	} else {
		inventoryData = inventory;
	}

	count++;

	//console.log("inventoryCallback " + count);
	//console.log(inventoryData);

	if ( count >= 4 ) {
		FleksyStore.init();
	}
}

function purchasedCallback( purchases ) {
  if ( typeof purchases == 'string' ) {
		purchaseData = $.parseJSON( purchases );
  } else {
		purchaseData = purchases;
  }

	count++;

	//console.log("purchasedCallback " + count);
	//console.log(purchaseData);

	if ( count >= 4 ) {
		FleksyStore.init();
	}
}

function pricesCallback( prices ) {
  if ( typeof prices == 'string' ) {
		priceData = $.parseJSON(prices);
  } else {
  	priceData = prices;
  }

	//console.log(priceData);

	if ( count >= 4 ) {
		FleksyStore.setBoxPrices(priceData);
	} else {
		_.delay(pricesCallback, 1000, prices);
	}
}

function fleksycoinspricesCallback ( fleksycoins ){
  if ( typeof fleksycoins == 'string' ) {
    priceData = $.parseJSON(fleksycoins);
  } else {
    priceData = fleksycoins;
  }
  
  //console.log(priceData);
  
  if ( count >= 4 ) {
    FleksyStore.setFleksyCoinsPrices(priceData);
  } else {
    _.delay(fleksycoinspricesCallback, 1000, fleksycoins);
  }
}

function selectedThemeCallback( key, result ) {
	//console.log(key);
	FleksyStore.highlightActiveTheme(key);
}

function purchaseResultCallback(id, result) {
	//console.log("purchaseResultCallback id: " + id + " result: " + result, true);
	if ( result === 'success' || result === '200 OK' ) {
		FleksyStore.purchaseBox( id );
		FleksyStore.settings.purchases.push(id);
	} else {
		//FleksyAPI.log( result );
	}
}

function selectedFreeThemeResultCallback(themeKey, result) {
//	FleksyAPI.log("selectedFreeThemeResultCallback");

	if ( result === 'success' || result === '200 OK' ) {
		FleksyStore.unlockFreeTheme( themeKey );
	} else {
		//FleksyAPI.log(result);
	}
}

function updateCoinsCallback(coins) {
    $(".coin_count").text(coins);

    if (coins == 0) {
        $(".coin_count").addClass("empty_wallet")
    }
}

var test_data = false;

var s,
FleksyStore = {
	settings: {
		themes: null,
		inventory: null,
		prices: null,
		purchases: null,
		freeInventory: null,
		active_theme: null,
		inventoryLookup: {},
		i18nStrings: null
	},

	/**
	 * Main init method.
	 */
	init: function() {
		s = this.settings;

		if ( test_data ) {
			s.themes = _.sortBy(_.map(JSON.parse(themeString), function(theme, key) {
				theme.key = key;
				return theme;
			}), 'style');
			s.inventory = JSON.parse(itemString).inventory;
			s.prices = JSON.parse(priceString);
			s.purchases = JSON.parse(purchaseString).purchases;
			s.freeInventory = JSON.parse(freeInventoryString).free_inventory;
			s.active_theme = active_themeData;

			FleksyStore.createThemeBuilderInterface(user_themes);
		} else {
			s.themes = _.sortBy(_.map(themeData, function(theme, key) {
				theme.key = key;
				return theme;
			}), 'style');
			s.inventory = inventoryData.inventory;
			s.purchases = purchaseData.purchases;
			s.freeInventory = freeInventoryData.free_inventory;
			s.active_theme = active_themeData;
			s.prices = priceData;
			s.i18nStrings = i18nData || null;
		}

		for ( var i = 0, len = s.inventory.length; i < len; i++ ) {
			s.inventoryLookup[s.inventory[i].key] = s.inventory[i];
		}

		$(".themes-purchased").html('');
		$("#boxes > .box").remove();
		this.resetPromoArea();
		this.createStore();
		this.setBoxPrices(s.prices);
		//console.log('init');
	},

	highlightActiveTheme: function(key) {
		var themes = $(".theme");
		themes.removeClass('active');
		themes.removeClass('loading');

		themes.filter(function() {
			return $(this).data('key') == key;
		}).addClass('active');


		// After highlighting the theme determine if we should show
		// or hide the themebuilder theme control buttons
		var $userThemeControls = $('.user-theme-controls');

		if ( $('.user-themes').find('.active').length ) {
			$userThemeControls.show();
		} else {
			$userThemeControls.hide();
		}
	},

	highlightLoadingActiveTheme: function(key) {
		var themes = $(".theme");
		themes.removeClass('loading');

		themes.filter(function() {
			return $(this).data('key') == key;
		}).addClass('loading');
	},

	/**
	 * Binds theme tapping events
	 */
	bindThemeTap: function() {
		$("#page").on('click', '.theme',  function(e) {
			var that = $(this);
			var parentBox = that.parents('.box');
			var boxTitle = parentBox.find('.box-title');
			var themeID = that.data('key');
			var topOffset = that.offset().top;
			var description = that.data('description');

			$("body").animate({
				scrollTop: topOffset-35
			}, 450);

			if ( !that.parents('.theme-builder').length ) {
				$('.user-theme-controls').fadeOut('fast');
			}

			FleksyAPI.scrollTo((topOffset*window.devicePixelRatio)-35);

			if ( parentBox.hasClass('promo') ) {
				parentBox.find('.box-callout b').text( that.data('name') );
			} //TODO Address this for the new design. (ask Bill)

			// get all other unlock messages and fade them out
			$(".box-title span.unlock").not(that.parents('.box').find(".box-title span.unlock")).hide();

			var thisItemCallout = that.parents('.box').find(".box-title span.unlock");
			if ( ! thisItemCallout.is(":visible") ) {
				thisItemCallout.show();
			}

			// Show theme description
			$( '.theme-descriptor' ).fadeOut( 'fast' );
			if ( parentBox.length && description ) {
				parentBox.find( '.theme-descriptor').text( description ).fadeIn( 'fast' );
			}

        	FleksyStore.highlightLoadingActiveTheme(themeID);

			FleksyAPI.selectTheme(themeID);

		});
	},

	/**
	 * Creates the Fleksy Store.
	 * Requires the themes collection and items collection objects
	 * Uses the maketheme() and makeBox() functions.
	 */
	createStore: function() {
		_.each( s.themes, function( themeObj ) {
			var themeKey = themeObj.key;
			if ( FleksyStore.isThemeUnlocked( themeKey ) ) {
				var theme = FleksyStore.makeTheme( themeKey );

				if ( themeKey == s.active_theme ) {
					theme.addClass('active').appendTo('.themes-purchased');
				} else {
					theme.appendTo('.themes-purchased');
				}
			}
		});

		if ( FleksyStore.isUserAllowedFreeTheme() ) {
			FleksyStore.createPromoArea();
		}

		_.each( s.inventory, function( boxObj ) {
			if ( ! FleksyStore.isBoxUnlocked( boxObj.key ) && boxObj.design ) {
				var box = FleksyStore.makeBox( boxObj.key );

				// if a box doesn't contain themes it means that
				// its themes are already unlocked, so skip it.
				if ( box.find(".theme").length ) {
					box.appendTo("#boxes");
				}
			}
		});

		$('.theme-builder').data('key', FleksyStore.getThemeBuilderIAPKey());
		$('.request-themes').css('display', 'block');
		$('.section-title').fadeIn('fast');
		FleksyStore.bindTweetButton();
	},

	setBoxPrices: function( prices ) {
		if ( prices ) {
			_.each(prices, function( priceObj, key ) {
				if ( priceObj.display_price ) {
					$(".box").filter(function() {
						return $(this).data('key') == key;
					}).find('.btn-purchase').text( priceObj.display_price );
				}
			});
		}
	},
  
  setFleksyCoinsPrices: function ( prices ){
    if ( prices ) {
      _.each(prices, function( priceObj, key ) {
             if ( priceObj.fleksycoins ) {
                  var res = $(".box").filter(function() {
                          return $(this).data('key') == key;
                                            });
                  res.find('.box-purchase-fc').show();
                  res.find('.btn-purchase-fc').text( priceObj.fleksycoins + 'fc' );
              }
             });
    }
  },

	/**
	 * Checks if a user is allowed free themes.
	 */
	isUserAllowedFreeTheme: function() {
		var freeThemesAllowed = s.freeInventory[0].themes;
		var freeThemesUnlocked = s.freeInventory[0].selected_themes.length;

		if ( freeThemesAllowed - freeThemesUnlocked <= 0 ) {
			return false;
		} else {
			return true;
		}
	},

	createPromoArea: function() {
		var promoArea = $("#free-inventory").find('.box');

		_.each(s.themes, function( theme ) {
			if ( theme.promo === true && !FleksyStore.isThemeUnlocked( theme.key ) ) {
				FleksyStore.makeTheme(theme.key).appendTo(promoArea.find('.group'));
			}
		});

		if ( promoArea.find(".theme").length ) {
			promoArea.fadeIn();
		}
	},

	resetPromoArea: function() {
		var promoArea = $("#free-inventory").find('.box');
		promoArea.hide().find('.theme').remove();
	},

	unlockFreeTheme: function( themeKey ) {
		var promoArea = $("#free-inventory");
		var freeTheme = promoArea.find($(".theme").filter(function() { return $(this).data('key') === themeKey }));
		var scrollY = $('.themes-purchased').height() - $('.theme').height()*1.5;

		$("body").animate({
			scrollTop: scrollY
		}, 450, function() {
			freeTheme.clone(true).addClass('popout').removeClass('double active').appendTo('.themes-purchased');
			promoArea.slideUp('slow');
		});

		FleksyAPI.scrollTo(scrollY*window.devicePixelRatio);
	},

	/**
	 * Returns all unlocked boxes' keys
	 *
	 * @param {Array} boxes An array containing box keys
	 * @return {Array} An array with unlocked item keys
	 */
	getUnlockedBoxes: function( boxes ) {
		// create a lookup object for our inventory
		var unlockedBoxes = [];

		_.each( boxes, function( key ) {
			if ( typeof s.inventoryLookup[key] !== 'undefined' && s.inventoryLookup[key].unlocks_keys && ! _.isEmpty(s.inventoryLookup[key].unlocks_keys) ) {
				unlockedBoxes = unlockedBoxes.concat( FleksyStore.getUnlockedBoxes( s.inventoryLookup[key].unlocks_keys ));
			}
		});

		_.each( boxes, function( key ) {
			if ( ( key in s.inventoryLookup ) ) {
				unlockedBoxes = unlockedBoxes.concat([key]); //TODO avoid infinite loop
			}
		});

		return _.uniq( unlockedBoxes, true );
	},

	/**
	 * Checks if a box is unlocked
	 *
	 * @param {object} boxKey The key of the item
	 * @return {boolean} True if box unlocked / False if box not unlocked
	 */
	isBoxUnlocked: function( boxKey ) {
		if ( $.inArray( boxKey, FleksyStore.getUnlockedBoxes( s.purchases ) ) == -1  ) {
			return false;
		} else {
			return true;
		}
	},

	/**
	 * Returns all unlocked themes' keys
	 *
	 * @return {Array} An array with all unlocked theme keys
	 */
	getUnlockedThemes: function() {
		var unlockedThemes = [];
		var	unlockedBoxes = FleksyStore.getUnlockedBoxes( s.purchases );
		var themeLookup = _.map(s.themes, function(theme) {
			return theme.key;
		});

		_.each( unlockedBoxes, function( key ) {
			if ( s.inventoryLookup[key].unlocks_keys && ! _.isEmpty(s.inventoryLookup[key].unlocks_keys) ) {
				_.each( s.inventoryLookup[key].unlocks_keys, function( unlockedKey ) {
					if ( ~themeLookup.indexOf(unlockedKey) ) {
						unlockedThemes.push( unlockedKey );
					}
				});
			}
		});

		_.each( s.freeInventory[0].selected_themes, function( unlockedKey ) {
			unlockedThemes.push( unlockedKey )
		});

		return _.uniq( unlockedThemes, true );
	},

	/**
	 * Checks if a theme is unlocked
	 *
	 * @param {string} themeKey The theme's unique ID
	 * @returns {boolean} True if theme unlocked / False if theme not unlocked
	 */
	isThemeUnlocked: function( themeKey ) {
		if ( $.inArray( themeKey, FleksyStore.getUnlockedThemes() ) == -1  ) {
			return false;
		} else {
			return true;
		}
	},

	/**
	 * Materializes a single theme square block.
	 * Extracts the required params from the theme's object (JSON) and
	 * applies the relative CSS.
	 *
	 * @param {string} themeKey The theme's unique ID
	 * @param {object} [themeObject] (optional) The complete object of the theme, if it's supplied then the method will not check the themes JSON and use this
	 * @param {string} [imagePath] (optional) The theme's background image path
	 * @return {object} theme The theme jQuery object, ready to be appended in the DOM
	 */
	makeTheme: function( themeKey, themeObject, imagePath ) {
		var themeObj = themeObject || _.where(s.themes, {"key": themeKey})[0];
		var themeColors = ( themeObj.background ) ? themeObj.background.gradient : '';
		var	themeImage = ( themeObj.background ) ?
		                    themeObj.background.preview ? themeObj.background.preview : themeObj.background.image
		                    : '';
		var themeName = themeObj.name;
		var dynamic;

		var theme = $("<div/>", { "class": "theme" });
		theme.data( "key", themeKey );
		theme.data( "name", themeName );
		theme.addClass(themeKey.replace(/\s+/g, ''));

		// Add the description
		if ( themeObj.hasOwnProperty('description') ) {
			theme.data( 'description', themeObj.description );
		}

		if ( _.contains(themeObj.special, 'dynamicWithApp') ) {
			dynamic = true;

			var splitColors = ( themeObj.dynamic ) ? themeObj.dynamic.background.gradient : '';
			var	splitStartColor = ( splitColors[0] ) ? tinycolor( splitColors[0] ).toHexString() : '';
			var	splitEndColor = ( splitColors[1] ) ?  tinycolor( splitColors[1] ).toHexString() : splitStartColor;
			theme.addClass('theme-dynamic');
			theme.append($("<div/>", { "class": "split" }));
			theme.find(".split").css({
				"background-image": "-webkit-linear-gradient(top," + splitStartColor + " 0%, " + splitEndColor + " 100%)"
			});
		}

		if ( themeColors ) {
			var colorStops = '';
			var stop;
			var colorNum = themeColors.length;

			if ( colorNum == 1 ) {
				colorStops = tinycolor( themeColors[0] ).toHexString() + " 0%, " + tinycolor( themeColors[0] ).toHexString() + " 100%";
			} else {
				_.each( themeColors, function( color, index ) {
					if ( index == 0 ) {
						stop = 7;

						if ( dynamic ) {
							colorStops += tinycolor( color ).brighten(12).toHexString() + " " + stop +  "%, ";
						} else {
							colorStops += tinycolor( color ).toHexString() + " " + stop +  "%, ";
						}

					}	else if ( index == colorNum - 1 ) {
						stop = 100;

						if ( dynamic ) {
							colorStops += tinycolor( color ).brighten(12).toHexString() + " " + stop +  "%";
						} else {
							colorStops += tinycolor( color ).toHexString() + " " + stop +  "%";
						}

					} else {
						stop = (100 / (colorNum - 1))*index + 7;
						if ( dynamic ) {
							colorStops += tinycolor( color ).brighten(12).toHexString() + " " + stop +  "%, ";
						} else {
							colorStops += tinycolor( color ).toHexString() + " " + stop +  "%, ";
						}

					}
				});
			}

			theme.css({
				"background-image": "-webkit-linear-gradient(top, " + colorStops + ")"
			});
		}

		var themeImagePath = typeof imagePath === 'undefined' ? 'images/' : imagePath + '/';

		if ( themeImage ) {
			theme.css({
				"background-color": tinycolor( themeColors[0] ).toHexString(),
				"background-image": "url(" + themeImagePath + themeImage +")"
			});
		}

		// Append distinguishing icon
		if ( themeObj.icon ) {
			var themeIcon = $("<i/>", { "class": themeObj.icon.icon_class });
			themeIcon.css('color', themeObj.icon.color);
			theme.append(themeIcon);
		}

		return theme;
	},

	/**
	 * Creates a box.
	 * Extracts required params, and cross-references with
	 * the theme collection and prices collection objects to fetch the bundled themes and create
	 * the box DOM object.
	 *
	 * @param {string} boxKey The box's unique ID
	 * @return {object} box The box jQuery object, ready to be appended in the DOM
	 */
	makeBox: function( boxKey ) {
		var boxObj = _.findWhere(s.inventory, {key: boxKey}),
				$slot = $('<i class="icon_buy_slot item-slot"></i>')
				themesLookup = _.map(s.themes, function(theme) {
					return theme.key;
				});

		if ( !boxObj.design ) return;

		var box = $(".box.template").clone().removeClass('template');
		var themeArea = box.find('.group');
		var boxSlots = box.find('.box-slots');
		var	boxBgColor = ( boxObj.design ) ? boxObj.design.background : '';

		// Set our box ID in the HTML
		box.data( 'key', boxKey );
		box.attr( 'id', boxKey );

		// Get the themes referenced from this box and all boxes attached to it
		// and append them to our themes. If box1 unlocks box2, box2's themes should be
		// also appended in box1.
		var themeBackgrounds = [];
		var batchedBoxes = FleksyStore.getUnlockedBoxes( boxObj.unlocks_keys ).concat( boxKey );

		_.each( batchedBoxes, function( batchedBox ) {
			var bundledItem = _.findWhere(s.inventory, {key: batchedBox});

			_.each( bundledItem.unlocks_keys, function( themeKey ) {
				if ( ~themesLookup.indexOf(themeKey) ) { // check if it's a theme
					var themeObj = _.where(s.themes, {"key": themeKey})[0];

					// if the theme is unlocked (purchased before somehow, do not show it again in a bundle)
					if ( ! FleksyStore.isThemeUnlocked( themeKey ) ) {
						FleksyStore.makeTheme( themeKey ).insertBefore( boxSlots );

						if ( themeObj.background && themeObj.background.image ) {
						    if (themeObj.background.preview) {
						        themeBackgrounds.push( themeObj.background.preview );
						    } else {
							    themeBackgrounds.push( themeObj.background.image );
							}
						}
					}
				}

				// check if it's an extension slot
				if ( FleksyStore.isSlot( themeKey ) ) {
					$slot.clone(true).data('key', themeKey).appendTo( boxSlots );
				}
			});
		});

		// Set the title
		box.find('.box-title').append( boxObj.name );

		// Set branded legal text if applicable
		if ( boxObj.design && boxObj.design.legal ) {
			themeArea.append('<p class="legal-text">'+boxObj.design.legal+'</p>');
		}

		// Style what's left on the box
		if ( boxBgColor ) {
			themeArea.css({
				"background-color": tinycolor(boxBgColor).toRgbString()
			});
		}

		// Set the background
		if ( boxObj.design.image ) {
			themeArea.css({
				"background-image": "url(images/" + boxObj.design.image +")"
			});
		} else if ( themeBackgrounds.length ) {
			themeArea.css({
				"background-image": "url(images/" + themeBackgrounds[0] +")"
			});
		}

		box.find('.box-callout').text(boxObj.design.byline.text).css({
			"color": boxObj.design.byline.text_color
		}); //TODO let's see if we still need this

		box.find('.legal-text').css({
			"color": boxObj.design.byline.text_color
		});

		// Give a border outline to themes that their box's byline color is not the default
		if ( boxObj.design.byline && tinycolor( boxObj.design.byline.text_color ).toHexString()  !== '#404040' ) {
			box.find('.theme').css({
				'border-width': '1px',
				'border-style': 'solid',
				'border-color':  tinycolor( boxObj.design.byline.text_color ).setAlpha(.4).toRgbString()
			});

			box.find('.theme-descriptor').css({
				'color': tinycolor( boxObj.design.byline.text_color )
			});
		}
    
    box.find('.box-purchase-fc').hide();

		if ( boxObj.design.discount && boxObj.design.discount.text ) {
			box.find('.box-badge').html(boxObj.design.discount.text).css({
				"color": boxObj.design.discount.text_color,
				"background-color": boxObj.design.discount.background
			}).fadeIn();
		}

		return box;
	},

	/**
	 * Checks if something is a slot (basically if it contains "slot" substring).
	 *
	 * @param {string} key
	 * @return {number} 0 for false, any other for true
	 */
	isSlot: function(key) {
		return ~key.indexOf('slot');
	},

	/**
	 * Box purchase handling.
	 *
	 * @param {string} boxKey The box's unique ID
	 */
	purchaseBox: function( boxKey ) {
		// Find possible boxes that are included in this box and
		// grab their jQuery DOM objects
		var box = $('.box').filter(function () { return $(this).data('key') === boxKey; });
		var unlockedBoxes = FleksyStore.getUnlockedBoxes( Array(boxKey) );
		var scrollLocation = $('.themes-purchased').height() - $('.theme').height()*1.5;

		// Animate to top > pop in themes > slideUp boxes
		$("body").animate({
			scrollTop: scrollLocation
		}, 450, function() {
			FleksyAPI.scrollTo(scrollLocation*window.devicePixelRatio);
			var boxThemes = box.find(".theme");

			if ( !box.hasClass('theme-builder') ) {
				$.each(boxThemes, function() {
					var that = $(this);
					var themeKey = that.data('key');
					var existingThemes = $(".themes-purchased").find('.theme');

					if ( ! existingThemes.filter(function () {return $(this).data('key') === themeKey; }).length ) {
						$(this).clone(true).addClass('popout').removeClass('double active').appendTo('.themes-purchased');

						$(".theme", "#boxes").filter(function () {return $(this).data('key') === themeKey; }).remove();
					}
				});

				$("#boxes .box").filter(function() {
					return $(this).find('.theme').length == 0;
				}).slideUp(function() {
					$(this).remove();
				});
			}
		});
	},

	filterColorCode: function( color ) {
		var hex;

		if ( color.length == 9 ) { // has alpha specified
			hex = "#" + color.substr(3);
		} else if ( color.length == 7 ) { // has no alpha specified
			hex = color;
		} else {
			hex = '#FFFFFF'; //defaults to white
		}

		return hex;
	},

	bindTweetButton: function() {
		var tweetBtn = $(".twitter-share-button"),
				iOS = /(iPad|iPhone|iPod)/g.test( navigator.userAgent),
				message;

		tweetBtn.css('display', 'block');

		if ( iOS ) {
			message = s.i18nStrings !== null ? s.i18nStrings.themes.tweet_text : ".@Fleksy lets you personalize your keyboard with awesome themes! I can’t wait for even more #FleksyThemes 😄 http://fleksy.com/getiOS ";
		} else {
			message = s.i18nStrings !== null ? s.i18nStrings.themes.tweet_text : ".@Fleksy lets you personalize your keyboard with awesome themes! I can’t wait for even more #FleksyThemes 😄 http://fleksy.com/upgradenow ";
		}

		tweetBtn.on( 'click', function( e ) {
			e.preventDefault();
			FleksyAPI.tweet( message );
		});
	},

	translateStrings: function( translations ) {
		$('[data-i18n]').each(function() {
			var that = $(this),
					pointer = that.data('i18n').split('.');

			that.html( translations[pointer[0]][pointer[1]] );
		});
	},

	bindExternalLinks: function() {
		$('.external-link').click(function(e) {
			e.preventDefault();
			var self = $(this);

			FleksyAPI.openURL(self.attr('href'));
		});
	},

    loadBanners: function(json) {
        if ( typeof json == 'string' ) {
            banner = $.parseJSON( json );
        } else {
            banner = json;
        }

        if ( banner ) {
            $(".notification_text").mousedown(function() {
                FleksyAPI.notificationClick(banner.url);
                $('.notifications_drawer').hide();
            });
            $(".notification_close").mousedown(function() {
                FleksyAPI.notificationHide(banner.url);
                $('.notifications_drawer').hide();
            });
            $(".notification_logo div img").attr('src', banner.logo);
            $(".notifications_drawer").css('background-image', 'url(' + banner.background + ')');
            $(".notification_text div").html(banner.text);
            $(".notifications_drawer").show();
            $(".notifications_drawer").attr('display', 'table');
        }
    },

	createFeaturedPromotionSlider: function() {
		var $swiperContainer = $('.swiper-featured'),
				$swiperWrapper = $swiperContainer.find('.swiper-wrapper');

		FleksyStore.fetchFeaturedPromotions().done(function(res) {
			if ( res.results.length ) {
				_.each(res.results, function(promo) {
					var $slide = $('<div/>', {
						'class': 'swiper-slide',
						'data-event': '{"eventName":"Viewed Promoted Content", "parameters": {"Campaign": '+ JSON.stringify(promo.campaign) +', "Type": "Banner", "Asset":"'+ promo.image.split('/').pop() +'", "View": "App_Banner"}}',
						'data-toast': promo.featured_text || '',
						'data-campaigns': JSON.stringify(promo.campaign),
						'data-action': promo.action || '',
						'data-action-argument-android': promo.action_argument_android || '',
						'data-action-argument-ios': promo.action_argument_ios || ''
					})
					.append($('<img/>', { 'src': promo.image }));

					$slide.appendTo($swiperWrapper);
				});

				FleksyStore.bindFeaturedPromotionSlider();
			}
		});
	},

	fetchFeaturedPromotions: function() {
		return $.ajax({
			url: 'https://www.fleksy.me/api/v1/banners',
			method: 'GET',
			dataType: 'json'
		});
	},

	bindFeaturedPromotionSlider: function() {
		var $swiper = $('.swiper-featured'),
				slidesNo = $swiper.find('.swiper-slide').length,
				shouldLoop = slidesNo > 1;

		var featuredSwiper = new Swiper($swiper, {
			direction: 'horizontal',
			loop: shouldLoop,
			speed: 700,
			spaceBetween: 0,
			autoplay: 4000,
			autoplayDisableOnInteraction: false,
			onTouchStart: function(swiper, event) {
				FleksyAPI.holdHorizontalSlide();
			},
			onTouchMove: function(swiper, event) {
				FleksyAPI.holdHorizontalSlide();
			},
			onTouchEnd: function(swiper, event) {
				FleksyAPI.resumeHorizontalSlide();
			},
			onInit: function(swiper) {
				$swiper.find('.swiper-slide').on('click', function(e) {
					var $that = $(this);
					var action = $that.data('action');
					var actionArgument = $that.data('action-argument-'+FleksyStore.getUserAgent());
					if ( typeof BannerActions[action] !== 'undefined' ) {
						BannerActions[action](actionArgument);
					}
				});

				if ( slidesNo === 1 ) {
					var $activeBanner = $swiper.find('.swiper-slide').eq(swiper.activeIndex),
							event = $activeBanner.data('event'),
							campaigns = $activeBanner.data('campaigns');

					setTimeout(function() {
						if ( FleksyStore.isElementInViewport($swiper) && !isAppDestroyed ) {
							FleksyAPI.sendEvent(JSON.stringify(event));
							FleksyAPI.incrementPromotedContentSlots(1);
							FleksyAPI.incrementPromotedContentViewsForCampaign('{"campaigns": ' + JSON.stringify(campaigns) + '}');
						}
					}, 1000);
				}

				var alreadyFired = false;
				$swiper.appear();
				$swiper.on('appear', function() {
					if ( !alreadyFired ) {
						setTimeout(function() {
							var $activeBanner = $swiper.find('.swiper-slide').eq(swiper.activeIndex),
									event = $activeBanner.data('event'),
									campaigns = $activeBanner.data('campaigns');

							if ( FleksyStore.isElementInViewport($swiper) && !isAppDestroyed ) {
								FleksyAPI.sendEvent(JSON.stringify(event));
								FleksyAPI.incrementPromotedContentSlots(1);
								FleksyAPI.incrementPromotedContentViewsForCampaign('{"campaigns": ' + JSON.stringify(campaigns) + '}');
							}
						}, 1000);
					}

					alreadyFired = true;
				});

				$swiper.on('disappear', function() {
					alreadyFired = false;
				});
			},
			onSlideChangeEnd: function(swiper) {
				var $activeBanner = $swiper.find('.swiper-slide').eq(swiper.activeIndex),
						event = $activeBanner.data('event'),
						campaigns = $activeBanner.data('campaigns');

				setTimeout(function() {
					if ( FleksyStore.isElementInViewport($('.swiper-featured')) && isUserAtThemeTab && !isAppDestroyed ) {
						//console.log(event);
						FleksyAPI.sendEvent(JSON.stringify(event));
						FleksyAPI.incrementPromotedContentSlots(1);
						FleksyAPI.incrementPromotedContentViewsForCampaign('{"campaigns": ' + JSON.stringify(campaigns) + '}');
					}
				}, 1000);
			}
		});
	},

	isElementInViewport: function(el) {
		if (typeof jQuery === "function" && el instanceof jQuery) {
      el = el[0];
  	}

		var rect = el.getBoundingClientRect();
			return (
					rect.top >= -70 &&
					rect.left >= 0 &&
					rect.bottom <= (window.innerHeight || document.documentElement.clientHeight) &&
					rect.right <= (window.innerWidth || document.documentElement.clientWidth)
			);
	},

	/**
	* Creates the theme builder interface in the Webstore
	*
	* @param {object} themes
	* @param {string} imagePath
	*/
	createThemeBuilderInterface: function(themes, imagePath) {
		var $builderContainer = $('.theme-builder'),
				$userThemecontainer = $('.themes-custom');

		$userThemecontainer.html('');

		if ( themes ) {
			_.each(themes, function(theme, key) {
				FleksyStore.makeTheme(key, theme, imagePath).appendTo($userThemecontainer);
			});
		}

		$userThemecontainer.append('<a class="make-new-theme" href="#"><i class="icon-plus"></i></a>');

		$('.make-new-theme').on('click', function(e) {
			e.preventDefault();
			$builderContainer.find('.user-theme-controls').hide();
			FleksyAPI.loadThemeBuilder();
		});

		function getActiveUserThemeKey() {
			return $builderContainer.find('.theme.active').data('key');
		}

		// Handle custom theme tap
		var $buttonsWrap = $builderContainer.find('.user-theme-controls');
		$builderContainer.find('.theme').on('click', function(e) {
			$buttonsWrap.fadeIn('fast');
		});

		// iOS can load this a few times resulting in multiple event bindings
		// Unbind event before rebinding
		$('.btn-edit-user-theme, .btn-delete-user-theme, .btn-share-user-theme').off('click');

		// Handle theme sharing
		$('.btn-share-user-theme').on('click', function(e) {
			e.preventDefault();
			FleksyAPI.shareTheme(getActiveUserThemeKey());
		});

		// Handle theme edit
		$('.btn-edit-user-theme').on('click', function(e) {
			e.preventDefault();
			$('.user-theme-controls').hide();
			FleksyAPI.loadThemeBuilder(getActiveUserThemeKey());
		});

		// Handle theme delete
		$('.btn-delete-user-theme').on('click', function(e) {
			e.preventDefault();
			FleksyAPI.dismissKeyboard();
			FleksyAPI.deleteUserTheme(getActiveUserThemeKey());
		});

		// Handle earn more coins
		$('.coin_earn_button').on('click', function(e) {
                              			e.preventDefault();
                            			FleksyAPI.dismissKeyboard();
                              			FleksyAPI.coinsEarn();
                              		});

        // Handle coin help
		$('.coin_help_button').on('click', function(e) {
                              			e.preventDefault();
                            			FleksyAPI.dismissKeyboard();
                              			FleksyAPI.coinsHelp();
                              		});
	},

	/**
	* Gets the Theme Builder's IAP key from the inventory
	*
 	* @return {String} themebuilder key
	*/
	getThemeBuilderIAPKey: function() {
		var key = '';

		_.each(s.inventory, function(item) {
			if ( ~item.key.indexOf('themebuilder') ) {
				key = item.key;
			}
		});

		return key;
	},

	/**
	* Checks if the Theme Builder is purchased
	*
 	* @return {number} -1 or 0
	*/
	isThemeBuilderUnlocked: function() {
		return ~s.purchases.indexOf(FleksyStore.getThemeBuilderIAPKey());
	},

	/**
	* Determines whether to display the IAP Themebuilder or the Unlocked one.
	*/
	setupThemeBuilderState: function() {
		var $themebuilderIAP = $('.box.theme-builder'),
				$themebuilderUnlocked = $('.user-themes-wrap');

		if ( FleksyStore.isThemeBuilderUnlocked() ) {
			$themebuilderIAP.hide();
			$themebuilderUnlocked.show();
		} else {
			$themebuilderIAP.show();
			$themebuilderUnlocked.hide();
		}
	},

	setNewUserThemeButtonState: function() {
		var $themebuilder = $('.theme-builder'),
				$themes = $themebuilder.find('.theme'),
				$newThemeButton = $themebuilder.find('.make-new-theme');

		if ( $themes.length > 15 ) { //FIXME find a way to do this smarter on the first chance if we're ever going to use this method.
			$newThemeButton.hide();
		} else {
			$newThemeButton.show();
		}
	},

	getUserAgent: function() {
		var iOS = /(iPad|iPhone|iPod)/g.test( navigator.userAgent );

		if ( iOS ) {
			return 'ios';
		} else {
			return 'android';
		}
	}
};

(function() {

	var iOS = /(iPad|iPhone|iPod)/g.test( navigator.userAgent );
	if ( iOS ) {
		$("body").addClass("ios");
	}

	FleksyStore.bindThemeTap();
	FleksyStore.bindExternalLinks();

	//test purposes only TBR
	$('.refresh').on('click', function(e) {
		location.reload();

		e.preventDefault();
	});

	// Handle tap purchase
	$("#boxes").on('click', '.btn-purchase', function(e) {
		var that = $(this);
		var	box = that.parents('.box');
		var	boxKey = box.data('key');

		if ( box.hasClass("promo") ) {
			var activeThemeKey = box.find('.theme.active').data('key');

			if ( activeThemeKey ) {
				FleksyAPI.selectFreeTheme( activeThemeKey );
			} else {
				FleksyAPI.showToast('Please select a theme first.', true);
			}
		} else {
			FleksyAPI.purchaseBox( boxKey );
		}

		e.preventDefault();
	});
 
 // Handle tap fleksycoins purchase
 $("#boxes").on('click', '.btn-purchase-fc', function(e) {
   var that = $(this);
   var  box = that.parents('.box');
   var  boxKey = box.data('key');
   FleksyAPI.purchaseFleksyCoinsBox( boxKey );
   
   e.preventDefault();
  });
 
})();


if ( test_data ) { //TODO
	FleksyStore.init();
}

//Only for testing purposes, brings console logs in the DOM, TBR
/*
if (typeof console  != "undefined")
	if (typeof console.log != 'undefined')
		console.olog = console.log;
	else
		console.olog = function() {};

console.log = function(message) {
	console.olog(message);
	$('.data').append('<p>' + message + '</p>');
};
console.error = console.debug = console.info =  console.log;
*/